* **************************************************************************** *
* **************************************************************************** *
* Women's Labor Force Participation in Nepal:                                  *
* An Exploration of The Role of Social Norms                                   *
* Replication .do files 													   * 
* 03: Mster .do file for Data Analysis                                         *
* 2024                                                                         *
* **************************************************************************** *
* **************************************************************************** *

/*
* Author: Aishwarya Patil
* Program Purpose: This master dofile runs all required dofiles to reproduce
*                  the analyses presented the paper.   
* Description: This file executes the main and annex analyses by invoking
*              respective sub-dofiles.   
*
* Date last modified: May 2024
*------------------------------------------------------------------------------*
* Datasets Required: 
* - NPL_SN_REGRESS.dta
* - 
*
* Unique Identificator: [Specify if there's any unique identifier for the datasets]
*
* Outline: 
*  Part 1: Execute analyses included in the main body 
*  Part 2: Execute analyses included in the annex 
*/


********************************************************************************
*                       PREPARATION AND MAIN SETTINGS 
********************************************************************************
if 1{

   local paper_name "SocialNormsFLFPNepal"    
   local MainAnalysis     1  // Set to 1 to execute main analysis; 0 to skip 
   local AnnexAnalysis    1  // Set to 1 to execute annex analysis; 0 to skip
   local AdditionalAnnex  0  // Set to 1 to execute additional annex analysis; 0 to skip
  
}


********************************************************************************
*                     PART 1. MAIN ANALYSIS EXECUTION                          *
******************************************************************************** 
if (`MainAnalysis' == 1) {

    do "$dofiles/analyze/sub-dofiles/03a_mainbody.do"
	
}

********************************************************************************
*                   PART 2.  APPENDIX ANALYSIS EXECUTION                       *
******************************************************************************** 
if (`AnnexAnalysis' == 1) {
	
    do "$dofiles/analyze/sub-dofiles/03b_annex.do"
	
}

if (`AdditionalAnnex' == 1) {
	
    do "$dofiles/analyze/sub-dofiles/misc_annex.do"
	
}

******************************************************************************** 
/// END OF DOFILE
